Name: paxctld
Version: 1.2.7
Release: 1%{?dist}
Summary: PaX flags maintenance daemon
Group: admin
License: GPLv2
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts
URL: https://grsecurity.net
Source: https://grsecurity.net/paxctld-1.2.7.tgz

%description
paxctld is a daemon that automatically applies PaX flags to binaries on
the system.  These flags are applied via user extended attributes and are
refreshed on any update to the binaries specified in its configuration file.

%package systemd
Summary: PaX flags maintenance daemon
Group: admin
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%description systemd
paxctld is a daemon that automatically applies PaX flags to binaries on
the system.  These flags are applied via user extended attributes and are
refreshed on any update to the binaries specified in its configuration file.
This package supports those who have been forced to run only systemd by their
distro.

%prep
%setup -q

%build
make %{?_smp_mflags}

%install
%make_install
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -d $RPM_BUILD_ROOT/etc/systemd/system
install -m755 rpm/paxctld.init $RPM_BUILD_ROOT/etc/rc.d/init.d/paxctld
install -m644 rpm/paxctld.service $RPM_BUILD_ROOT/etc/systemd/system

%post
# This adds the proper /etc/rc*.d links for the script
/sbin/chkconfig --add paxctld
/sbin/service paxctld start >/dev/null 2>&1

%post systemd
/usr/bin/systemctl enable paxctld.service >/dev/null 2>&1 || :

%preun
if [ $1 -eq 0 ] ; then
    /sbin/service paxctld stop >/dev/null 2>&1
    /sbin/chkconfig --del paxctld
fi

%preun systemd
%systemd_preun paxctld.service

%postun
if ["$!" -ge "1" ] ; then
    /sbin/service paxctld condrestart >/dev/null 2>&1 || :
fi

%postun systemd
%systemd_postun paxctld.service

%files
%defattr(-,root,root)
%attr(0755,root,root) /sbin/paxctld
%attr(0644,root,root) %{_mandir}/man8/paxctld.8.gz
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/paxctld.conf
%attr(0755,root,root) %config %{_sysconfdir}/rc.d/init.d/paxctld
%doc

%files systemd
%defattr(-,root,root)
%attr(0755,root,root) /sbin/paxctld
%attr(0644,root,root) %{_mandir}/man8/paxctld.8.gz
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/paxctld.conf
%attr(0644,root,root) %config %{_sysconfdir}/systemd/system/paxctld.service
%doc

%changelog
* Fri Feb 21 2025 Brad Spengler <spender@grsecurity.net> 1.2.7-1
- Log and reject duplicate entries, from Mathias Krause
- Fix a duplicate OpenJDK entry in paxctld.conf
- Ignore files in config directories ending in ~, reported by Jozsef
  Kadlecsik

* Wed Sep 25 2024 Brad Spengler <spender@grsecurity.net> 1.2.6-1
- Fixed earlier processing of all inotify events, from Mathias Krause
- Fixes to watch ID handling, from Mathias Krause
- Ignore trailing whitespace in paxctld.conf, from Mathias Krause
- Log re-initialization reason, from Mathias Krause
- Default paxctld.conf updates for newer distros, third-party software

* Mon Aug 3 2020 Brad Spengler <spender@grsecurity.net> 1.2.5-1
- Update "nonroot" documentation, ensure the paxctld service gets enabled
  after install on Debian-based systems, and provide documentation for
  building deb and rpm packages, from Mathias Krause

* Mon Jul 20 2020 Brad Spengler <spender@grsecurity.net> 1.2.4-1
- Various fixes, including processing all inotify events instead of
  the first one, not leaking watch IDs, setting xattrs only when
  necessary, ignoring xattr set requests on non-regular files, command-line
  overflow in non-root mode, support for Chrome's method of installation
  (moving a pre-populated directory into place), fixed handling of "nonroot"
  option in paxctld.conf and updated its associated documentation, from
  Mathias Krause
- Updated default paxctld.conf to support the latest distributions

* Wed Aug 21 2019 Brad Spengler <spender@grsecurity.net> 1.2.3-1
- Updated default paxctld.conf for CentOS 7/Debian 9 32bit/Ubuntu 19.04
  desktop compatibility
- Fixed permission on paxctld.service file installed by the systemd variant
  of the package to address a recent runtime warning, reported by Vito Fang
- Added a non-root mode for paxctld that reads from ~/.paxctld/paxctld.conf
  by default, with additional configs allowed in ~/.paxctld/paxctld.d
- Updated documentation to reflect new mode

* Sun Oct 1 2017 Brad Spengler <spender@grsecurity.net> 1.2.2-1
- Updated default paxctld.conf to improve Debian 9 usability

* Sun Jul 23 2016 Brad Spengler <spender@grsecurity.net> 1.2.1-1
- Updated default paxctld.conf to improve Ubuntu usability
- Updated chrome/firefox settings now that the anti-defense
  "features" of firefox in particular have been fixed

* Sun Jul 17 2016 Brad Spengler <spender@grsecurity.net> 1.2-1
- Added support for filesystems that don't provide d_type, from Damir Vandic:
  https://forums.grsecurity.net/viewtopic.php?f=1&t=4484

* Tue Feb 9 2016 Brad Spengler <spender@grsecurity.net> 1.1-1
- Added support for pathnames with spaces, from Austin Seipp

* Wed Dec 23 2015 Brad Spengler <spender@grsecurity.net> 1.0-4
- Fixed a non-security-relevant crash on too-large paxctld.conf files,
  reported by Jurriaan Bremer
- Fixed the xattrs set by paxctld -- due to the nonintuitivity of PaX
  xattr parsing which differed from some previous marking methods, it
  ended up being the case that if EMUTRAMP was enabled in the kernel,
  all binaries marked with xattrs via paxctld were running with EMUTRAMP
  enabled.  Running the updated version of paxctld will fix the issue
  on binaries listed in paxctld.conf.  This issue was found via an internal
  audit.

* Thu Oct 29 2015 Brad Spengler <spender@grsecurity.net> 1.0-3
- Added support for reading extra config files from /etc/paxctld.d
  Files beginning with '.' are ignored, as are any non-regular files
  in the directory

* Thu Mar 12 2015 Brad Spengler <spender@grsecurity.net> 1.0
- Added systemd-specific subpackage from 'tweek' on the forums,

* Wed Dec 17 2014 Brad Spengler <spender@grsecurity.net> 1.0
- Initial release
